#!/usr/bin/awk -f

BEGIN{

de = -9999;

### Read the connectivity.out file 

	while (getline < ARGV[1] >0){
		if($1=="cutoffCO:") cutoff_CO=$2
		if($1=="cutoffCA:") cutoff_CA=$2
		if($1=="cutoffCB:") cutoff_CB=$2
		if($1=="cutoffHA:") cutoff_HA=$2
		if($1=="cutoffHN:") cutoff_HN=$2
		if($1=="cutoffpN:" || $1=="cutoffN:") cutoff_pN=$2
		if($1=="cutoffnN:") cutoff_nN=$2
		if($1=="cutoffnHN:") cutoff_nH=$2
	}close (ARGV[1])
	
	cutoff[1]=cutoff_pN;
	cutoff[2]=cutoff_HN;
	cutoff[3]=cutoff_CO;
	cutoff[4]=cutoff_CA;
	cutoff[5]=cutoff_CB;
	cutoff[6]=cutoff_HA;
	cutoff[7]=cutoff_nN;
	cutoff[8]=cutoff_nH;
	
	while(getline < "Cs_expt.tab" >0){
		##  $2 = PK id as given by the user , $1 = numbering id of PK id
		PK_id[$1] = $2  
		PR_id[$2] = $1
	}close ("Cs_expt.tab")

	while(getline < "PeaksProTuermchen" >0){
		
		if ($3==14){
			pseudoResidue_ID = $1;
			for (j=1;j<=14;j++){
				NMatrix[pseudoResidue_ID,j] = $(j+3)
			}
		}
		
		if ($3==6){
			pseudoResidue_ID = $1;
			for (j=1;j<=6;j++){
				TMatrix[pseudoResidue_ID,j] = $(j+3)
			}
		}
	}close ("PeaksProTuermchen")
	
### Read the assignment_AA.out and print out assignment_AA_verfd.out.
	while(getline < "assignment_AA.out" >0){
		res[++i]=$1;
		nfield[i]=NF;
		PK2AA[i] = $2
		reli_AA = $3
		
		prev_res = PR_id[PK2AA[i-1]];
		curr_res = PR_id[PK2AA[i]];
		next_res = PR_id[PK2AA[i+1]];	
		
		if (res[i] ~ "PRO" && TMatrix[curr_res,2] != de){	
			if($3=="(FL)" || $3=="(Fl)" || $3=="(L)" || $3=="(l)"){$2=" ";$3=" ";}
			if($3=="(F)" || $3=="(FH)" || $3=="(FM)" || $3=="(Fm)" || $3=="(H)" || $3=="(M)" || $3=="(m)"){$3="(L)"}
		}
		
		if (res[i] ~ "GLY" && TMatrix[curr_res,5] != de){	
			if($3=="(FL)" || $3=="(Fl)" || $3=="(L)" || $3=="(l)"){$2=" ";$3=" ";}
			if($3=="(F)" || $3=="(FH)" || $3=="(FM)" || $3=="(Fm)" || $3=="(H)" || $3=="(M)" || $3=="(m)"){$3="(L)"}
		}
		
		#if (nfield[i]>2 && nfield[i-1]>2 && i>1){
		if (curr_res != " " && prev_res != " " && i>1){
			
			##### verify connectivity ####
				Korr = 1;
				n_Korr = 1;

				for (n=1;n<=6;n++){
					if (TMatrix[prev_res,n] != de && NMatrix[curr_res,n+6] != de && TMatrix[prev_res,n] > 0 && NMatrix[curr_res,n+6] > 0){
						if (sqrt((NMatrix[curr_res,n+6] - TMatrix[prev_res,n])*(NMatrix[curr_res,n+6] - TMatrix[prev_res,n])) > cutoff[n]){
							Korr = 0;
						}
					}
				}
				
				for (m=1;m<=2;m++){
					if (TMatrix[next_res,m] != de && NMatrix[curr_res,m+12] != de && TMatrix[next_res,m] > 0 && NMatrix[curr_res,m+12] > 0){
						if (sqrt((NMatrix[curr_res,m+12] - TMatrix[next_res,m])*(NMatrix[curr_res,m+12] - TMatrix[next_res,m])) > cutoff[m+6])
							n_Korr = 0;
					}
				}

# 				if (TMatrix[next_res,2] != de && NMatrix[curr_res,14] != de && TMatrix[next_res,2] > 0 && NMatrix[curr_res,14] != 0){
# 					if (sqrt((NMatrix[curr_res,14] - TMatrix[next_res,2])*(NMatrix[curr_res,14] - TMatrix[next_res,2])) > cutoff[8])
# 						nH_Korr = 0;
# 				}
			
			
			if(Korr<1 || n_Korr<1){
				if($3=="(FL)" || $3=="(Fl)" || $3=="(L)" || $3=="(l)"){$2=" ";$3=" ";}
				if($3=="(F)" || $3=="(FH)" || $3=="(FM)" || $3=="(Fm)" || $3=="(H)" || $3=="(M)" || $3=="(m)"){$3="(L)"}
			
			}
		}	
		#printf "%-11s%s%5s\n",$1,$2,$3
		printf "%-11s%s%5s\n",$1,$2,$3 > "assignment_AA_verfd.out"
	}close("assignment_AA.out")

 	com = "mv assignment_AA_verfd.out assignment_AA.out"
 	system(com)
 	close(com)
}
