#!/usr/bin/awk -f

BEGIN{

### Read table names of fixed assignment and chemical shift tables
	while(getline < ARGV[1] >0){
		if($1=="fixAss:"){
			tablename = $2
		}
	}close(ARGV[1])


### Read the fixed assignment table	
	if(tablename != "NO"){
		
		while(getline < tablename >0) if($1 !~ /^#/ && NF>=2){
			count = 0
			for(i=2;i<=NF;i++) if ($i ~ /[0-9]/){
				count++
			}
			
			if(count == 1){
				for(i=2;i<=NF;i++) if ($i ~ /[0-9]/){
					
					fix_PR_id = $1
					fix_AA_id = $i
					fixed_ass[fix_PR_id,fix_AA_id] = 1
					fixedPR[$i] = $1
					
				}				
			}
				
		}close(tablename)
	
	}
	
### Read the assignment_AA.out and store scores of assignment

	  i=0
	  while (getline < "assignment_AAs.out" > 0){
      	if ($1 ~ /[0-9]/){	
      		j=0
      		i++
      		best_score_PK2AA[i] = 0
      		AA[i] = $1
      		for(x=2;x<=NF;x=x+2){
      			j++
      			PK2AA[i,j] = $x
      			split($(x+1),temp,"[()]");
      			score_PK2AA[i,j] = temp[2]
      		  	if(j>1){
      		 		best_PK2AA[i] = (score_PK2AA[i,j]>best_score_PK2AA[i]) ? PK2AA[i,j] : best_PK2AA[i]
      		 		best_score_PK2AA[i] = (score_PK2AA[i,j]>best_score_PK2AA[i]) ? score_PK2AA[i,j] : best_score_PK2AA[i]
      		 	}
      		 	else{
      		 		best_PK2AA[i] = PK2AA[i,j]
      		 		best_score_PK2AA[i] = score_PK2AA[i,j]
      		 	}
      		}
      		PK2AA[i] = best_PK2AA[i]
      		PK[i] = best_PK2AA[i]
      		AA2PK[i] = $1 
      		reli[i] = best_score_PK2AA[i]
      		last_i = i
      	}
      }close ("assignment_AAs.out")
      
	
### Read the assignment_AA.out and print out assignment_AA_label.out.
	while(getline < "assignment_AA.out" >0){

		Degree = $3
		PR_id = $2
		AA_id = substr($1,5,length($1)-4)		
		
		if(fixed_ass[PR_id,AA_id]==1){
			if (PR_id == PK2AA[AA_id]){
				if (Degree == "(l)"){Degree = "(Fl)"}
				if (Degree == "(L)"){Degree = "(FL)"}
				if (Degree == "(m)"){Degree = "(Fm)"}
				if (Degree == "(M)"){Degree = "(FM)"}
				if (Degree == "(H)"){Degree = "(FH)"}
				PR_id = PK2AA[AA_id]
			}
			else if(PR_id != PK2AA[AA_id]){
				if (fixed_ass[PK2AA[AA_id],AA_id] == 1){
					Degree = "(F)"
					PR_id = PK2AA[AA_id]
				}
			}
		}
		
			
# 		if(fixedPR[AA_id] != 0){
# 			Degree = "(F)"
# 			PR_id = fixedPR[AA_id]
# 		}
		
		printf "%-10s %s %s\n", $1, PR_id, Degree > "assignment_AA_label.out"

	}close("assignment_AA.out")

 	com = "mv assignment_AA_label.out assignment_AA.out"
 	system(com)
 	close(com)
}
