#! usr/bin/awk -f


######  FUNCITON MY_SELECT  #####
function my_select(k, n, arr)
{

	l=1;
	ir=n;
	for (;;) {
		if (ir <= l+1) {
			if (ir == l+1 && arr[ir] < arr[l]) {
				temp=arr[l];arr[l]=arr[ir];arr[ir]=temp;  ## SWAP(arr[l],arr[ir])
			}
			return arr[k];
		} else {
			mid=int((l+ir)/2);
			temp=arr[mid];arr[mid]=arr[l+1];arr[l+1]=temp;   ##SWAP(arr[mid],arr[l+1])
			if (arr[l+1] > arr[ir]) {
				temp=arr[l+1];arr[l+1]=arr[ir];arr[ir]=temp;   ## SWAP(arr[l+1],arr[ir])
			}
			if (arr[l] > arr[ir]) {
				temp=arr[l];arr[l]=arr[ir];arr[ir]=temp;   ## SWAP(arr[l],arr[ir])
			}
			if (arr[l+1] > arr[l]) {
				temp=arr[l+1];arr[l+1]=arr[l];arr[l]=temp;   ## SWAP(arr[l+1],arr[l])
			}
			i=l+1;
			j=ir;
			a=arr[l];
			for (;;) {
				do i++; while (arr[i] < a);
				do j--; while (arr[j] > a);
				if (j < i) break;
				temp=arr[i];arr[i]=arr[j];arr[j]=temp;  ## SWAP(arr[i],arr[j])
			}
			arr[l]=arr[j];
			arr[j]=a;
			if (j >= k) ir=j-1;
			if (j <= k) l=i;
		}
	}
}

######  FUNCITON ROFUNC  #####
function rofunc(b, ndatat, yt, xt)
{
## Evaluate the RHS of this eqn 0 = SUMi(abs(Yi - A - BXi)) for a given value of B, 
## communication with the routine medfit is through global variables.

	for (j=1;j<=ndatat;j++){ 
		arr[j]=yt[j]-b*xt[j];
		temp1[j]=arr[j];
		temp2[j]=arr[j];
		temp3[j]=arr[j];
	}
	
	if ((ndatat%2)==0)  {    ## ndatat is even
		j=ndatat/2; 
		## aa=0.5*(my_select(j,ndatat,arr)+my_select(j+1,ndatat,arr));
		aa=0.5*(my_select(j,ndatat,temp1)+my_select(j+1,ndatat,temp2));
		# print "wow"aa
	}
	else {  				## ndatat is odd
		j=(ndatat+1)/2; 
		aa=my_select(j,ndatat,temp3);
		 # print "wow"j, ndatat, aa
	}
	
	abdevt=0.0;
	for (j=1;j<=ndatat;j++) {
		d=yt[j]-(b*xt[j]+aa);
		abdevt += sqrt(d**2);
		if (yt[j] != 0.0) {d /= (sqrt(yt[j]**2));}
		if (sqrt(d**2) > 1e-7) sum += d > 0.0 ? xt[j] : -xt[j];
	}
	return sum;
}

######  FUNCITON MEDFIT  #####
function medfit(x, y, ndata){
	
	ndatat=0;
	sx=0;sy=0;sxy=0;sxx=0;
	ax=0;ay=0;dx=0;dy=0;sdx=0;sdy=0;sdxdy=0;
	del=0;aa=0;bb=0;
	temp=0;chisq=0;
	med_e=0;mad_s=0;
	sigb=0;f1=0;b2=0;
	f2=0;b2=0;f=0;
	
	ndatat=ndata;
	
## /*As a first guess for a and b, we will find the least squares fitting line*/
	for (j=1;j<=ndata;j++) {
		sx += x[j];
		sy += y[j];
		sxy += x[j]*y[j];
		sxx += x[j]*x[j];
	}
## Find the means
	ax = sx/ndata;
	ay = sy/ndata;

## compute the correlation coefficient
	for (j=1;j<=ndata;j++) {
		dx = x[j]-ax;
		dy = y[j]-ay;
		sdx += dx*dx;
		sdy += dy*dy;
		sdxdy += dx*dy;
	}
	
	r = sdxdy/sqrt(sdx*sdy);
	
##// Least square solutions for line y=a+bx.
	del=ndata*sxx-sx*sx;
	aa=(sxx*sy-sx*sxy)/del;
	bb=(ndata*sxy-sx*sy)/del;
	
	for (j=1;j<=ndata;j++){
		temp=y[j]-(aa+bb*x[j]);
		chisq += (temp*temp);
	}

	
  # // The standard deviation will give some idea of how big an iteration step to take.
	sigb=sqrt(chisq/del);   ## standard deviation
	b1=bb;
	f1=rofunc(b1, ndatat, y, x);
	b2=bb+ (f1 > 0.0 ? sqrt((10.0*sigb)**2) : -(sqrt((10.0*sigb)**2)));

	 # print "primary Least squares solutions y=a+bx: a="aa"   b="bb "   std devn ="sigb "   f1="f1  "   b2="b2 "   r="r

 # // Guess bracket as 3-sigma away, in the downhill direction known from f1.	
	f2=rofunc(b2, ndatat, y, x);
	while (f1*f2 > 0.0) {  ## // Bracketing
		bb=2.0*b2-b1;
		b1=b2;
		f1=f2;
		b2=bb;
		f2=rofunc(b2, ndatat, y, x);
	}

 # // Refine until error a negligible number of std devn
	sigb=0.01*sigb;
	while (sqrt((b2-b1)**2) > sigb) {	## // Bisection.
		bb=0.5*(b1+b2);
		if (bb == b1 || bb == b2) break;
		f=rofunc(bb, ndatat, y, x);
		if (f*f1 >= 0.0) {
			f1=f;
			b1=bb;
		} else {
			f2=f;
			b2=bb;
		}
	}
	
	 printf "a = %10.4f\nb = %10.4f\nabdev = %10.4f\n", aa, bb, abdevt/ndata	

	#soln[a]=aa;
	#soln[b]=bb;
	#soln[abdev]=abdevt/ndata;
}


BEGIN{
	
	i=0
	while (getline < ARGV[1] > 0){
		++i
		res_id[i] = $1
		Ca[i] = $2
		temp_Ca1[i] = Ca[i]
		temp_Ca2[i] = Ca[i]
		temp_Ca3[i] = Ca[i]
		
# 		Cb[i] = $3
# 		temp_Cb1[i] = Cb[i]
# 		temp_Cb2[i] = Cb[i]
# 		temp_Cb3[i] = Cb[i]
		
		
		Ca_Cb[i] = $3
# 		Cb_Ca[i] = $4
		last_i = i
		
		
	} close (ARGV[1])
	
	# printf "The y=a+bx is fit to the data supplied y=delCx and x=delCa-delCb \n"
	
	## get the median of delCa 
	
		if ((last_i%2)==0)  {    ## last_i is even
			j=last_i/2; 
			med_ca=0.5*(my_select(j,last_i,temp_Ca1)+my_select(j+1,last_i,temp_Ca2));
		}
		else {  				## last_i is odd
			j=(last_i+1)/2; 
			med_ca=my_select(j,last_i,temp_Ca3);
		}
		
		
	## now get the Absolute deviations of the data points
	
		for (j=1;j<=last_i;j++){
			Ca_s_temp = Ca[j]-med_ca;
			Ca_s[j] = sqrt(Ca_s_temp**2);
			Ca_s_temp1[j] = Ca_s[j];
			Ca_s_temp2[j] = Ca_s[j];
			Ca_s_temp3[j] = Ca_s[j];
		}

	## Now Median of those Absolute deviations
	
		if ((last_i%2)==0)  {    ## last_i is even
			j=last_i/2; 
			mad_Ca_s=0.5*(my_select(j,last_i,Ca_s_temp1)+my_select(j+1,last_i,Ca_s_temp2));
		}
		else {  				## last_i is odd
			j=(last_i+1)/2; 
			mad_Ca_s=my_select(j,last_i,Ca_s_temp3);
		}
		
	## Calculate the robustness weight w, for each data point with Beaton and Tukey’s bisquare weight function, B, 
	## w[j] = B[e[j]/(6*mad_s)]
	## where, B[u] = 1 			[if abs(u)<1] 
	##			   = 0			 [otherwise] kick out outliers
		cx_ctr=0;
		for (j=1;j<=last_i;j++){
			Ca_u =	Ca[j]/(6*mad_Ca_s);
			if(sqrt(Ca_u**2)<0.75){
				cx_ctr++
				Cx_filt[cx_ctr] = Ca[j]
				Ca_Cb_filt[cx_ctr] = Ca_Cb[j]
			}
		}
		
	if(cx_ctr>10){		
	 	medfit(Ca_Cb_filt, Cx_filt, cx_ctr)
	}else{
	print "Number of reliable data is too few"
	}
}
