#! usr/bin/awk -f


BEGIN{

de = -9999
sde = "-"
ctr = 0;

ca_a_pos = 0; ca_b_pos = 0;
cb_a_pos = 0; cb_b_pos = 0;
co_a_pos = 0; co_b_pos = 0;

############### Read ca_lacs-pos-offset.out ##################################

	while (getline < "./ca_lacs-pos-offset.out" > 0){
		if($1=="a"){ca_a_pos=$3}
		if($1=="b"){ca_b_pos=$3}
		if($1=="abdev"){ca_abdev_pos=$3}
	}close ("./ca_lacs-pos-offset.out")
	
############### Read ca_lacs-neg-offset.out ##################################

	while (getline < "./ca_lacs-neg-offset.out" > 0){
		if($1=="a"){ca_a_neg=$3}
		if($1=="b"){ca_b_neg=$3}
		if($1=="abdev"){ca_abdev_neg=$3}
	}close ("./ca_lacs-neg-offset.out")
	
############### Read cb_lacs-pos-offset.out ##################################

	while (getline < "./cb_lacs-pos-offset.out" > 0){
		if($1=="a"){cb_a_pos=$3}
		if($1=="b"){cb_b_pos=$3}
		if($1=="abdev"){cb_abdev_pos=$3}
	}close ("./cb_lacs-pos-offset.out")
	
############### Read cb_lacs-neg-offset.out ##################################

	while (getline < "./cb_lacs-neg-offset.out" > 0){
		if($1=="a"){cb_a_neg=$3}
		if($1=="b"){cb_b_neg=$3}
		if($1=="abdev"){cb_abdev_neg=$3}
	}close ("./cb_lacs-neg-offset.out")

############### Read co_lacs-pos-offset.out ##################################

	while (getline < "./co_lacs-pos-offset.out" > 0){
		if($1=="a"){co_a_pos=$3}
		if($1=="b"){co_b_pos=$3}
		if($1=="abdev"){co_abdev_pos=$3}
	}close ("./co_lacs-pos-offset.out")
	
############### Read co_lacs-neg-offset.out ##################################

	while (getline < "./co_lacs-neg-offset.out" > 0){
		if($1=="a"){co_a_neg=$3}
		if($1=="b"){co_b_neg=$3}
		if($1=="abdev"){co_abdev_neg=$3}
	}close ("./co_lacs-neg-offset.out")


############### Get the average deviations for Ca and Cb ##################################

	if(ca_b_pos>=0 && ca_b_neg>=0)ca_a = 0.5*(ca_a_pos+ca_a_neg)
	if(ca_b_pos>=0 && ca_b_neg<0)ca_a = ca_a_pos
	if(ca_b_pos<0 && ca_b_neg>=0)ca_a = ca_a_neg
	if(ca_b_pos<0 && ca_b_neg<0)ca_a = 0
	
	if(cb_b_pos<0 && cb_b_neg<0)cb_a = 0.5*(cb_a_pos+cb_a_neg)
	if(cb_b_pos<0 && cb_b_neg>=0)cb_a = cb_a_pos
	if(cb_b_pos>=0 && cb_b_neg<0)cb_a = cb_a_neg
	if(cb_b_pos>=0 && cb_b_neg>=0)cb_a = 0
	
	if(co_b_pos>=0 && co_b_neg>=0)co_a = 0.5*(co_a_pos+co_a_neg)
	if(co_b_pos>=0 && co_b_neg<0)co_a = co_a_pos
	if(co_b_pos<0 && co_b_neg>=0)co_a = co_a_neg
	if(co_b_pos<0 && co_b_neg<0)co_a = 0
	
############### Read CSI-diff-assigned-res.out ##################################
col_N=0;col_H=0;col_C=0;col_CA=0;col_CB=0;col_HA=0;

col_pN=0;col_pH=0;col_pC=0;col_pCA=0;col_pCB=0;col_pHA=0;

col_nN=0;col_nH=0;

if(ca_a!=0 || cb_a!=0 || co_a!=0){

		while (getline < "./csi-diff-assigned-res.out" > 0){
			if($0 !~/^#/ && NF>1 && $1 !~/[0-9]/){
				for(i=4;i<=NF;i++){
					if($i=="delN" ){col_N=i}
					if($i=="delHN"){col_H=i}
					if($i=="delCO"){col_C=i}
					if($i=="delCA"){col_CA=i}
					if($i=="delCB"){col_CB=i}
					if($i=="delHA"){col_HA=i}
					if($i=="delN-1"){col_pN=i}
					if($i=="delHN-1"){col_pH=i}
					if($i=="delCO-1"){col_pC=i}
					if($i=="delCA-1"){col_pCA=i}
					if($i=="delCB-1"){col_pCB=i}
					if($i=="delHA-1"){col_pHA=i}
					if($i=="delN+1"){col_nN=i}
					if($i=="delHN+1"){col_nH=i}
				}
			}
		}close ("./csi-diff-assigned-res.out")
		
		csi_shifted_output = "./csi-diff-lacs-corr-assigned-res.out"
		ca_lacs_shifted_pos = ("./ca_lacs-pos-shifted.out")
		cb_lacs_shifted_pos = ("./cb_lacs-pos-shifted.out")
		co_lacs_shifted_pos = ("./co_lacs-pos-shifted.out")
	
		ca_lacs_shifted_neg = ("./ca_lacs-neg-shifted.out")
		cb_lacs_shifted_neg = ("./cb_lacs-neg-shifted.out")
		co_lacs_shifted_neg = ("./co_lacs-neg-shifted.out")
		
		while (getline < "./csi-diff-assigned-res.out" > 0){
			if($0 !~/^#/ && NF>1 && $1 ~/[0-9]/){
			
				printf "%-8s",$1 >> csi_shifted_output
				printf "%-20s",$2 >> csi_shifted_output
				printf "%5s",$3 >> csi_shifted_output  
				
				
				if(col_N>0){printf "%14s",$col_N  >> csi_shifted_output}
				if(col_H>0){printf "%14s",$col_H  >> csi_shifted_output}
				if(col_C>0) if($col_C!=sde){printf "%14.5f",($col_C-co_a)  >> csi_shifted_output}else{printf "%14s", $col_C  >> csi_shifted_output}
				if(col_CA>0) if($col_CA!=sde){printf "%14.5f",($col_CA-ca_a)  >> csi_shifted_output}else{printf "%14s", $col_CA  >> csi_shifted_output}
				if(col_CB>0) if($col_CB!=sde){printf "%14.5f",($col_CB-cb_a)  >> csi_shifted_output}else{printf "%14s", $col_CB  >> csi_shifted_output} 
				if(col_HA>0){printf "%14s",$col_HA  >> csi_shifted_output} 
				
				if(col_pN>0){printf "%14s",$col_pN  >> csi_shifted_output} 
				if(col_pH>0){printf "%14s",$col_pH  >> csi_shifted_output} 
				if(col_pC>0) if($col_pC!=sde){printf "%14.5f",($col_pC-co_a)  >> csi_shifted_output}else{printf "%14s", $col_pC  >> csi_shifted_output}
				if(col_pCA>0) if($col_pCA!=sde){printf "%14.5f",($col_pCA-ca_a)  >> csi_shifted_output}else{printf "%14s", $col_pCA  >> csi_shifted_output}
				if(col_pCB>0) if($col_pCB!=sde){printf "%14.5f",($col_pCB-cb_a)  >> csi_shifted_output}else{printf "%14s", $col_pCB  >> csi_shifted_output}
				if(col_pHA>0){printf "%14s",$col_pHA  >> csi_shifted_output}
				
				if(col_nN>0){printf "%14s",$col_nN  >> csi_shifted_output} 
				if(col_nH>0){printf "%14s",$col_nH  >> csi_shifted_output} 
				printf "\n" >> csi_shifted_output
	
	# 			if ($col_pCA!=sde && $col_pCB!=sde && ($col_pCA-$col_pCB)>=0){
	# 			
	# 				printf "%-8s%14.5f%14.5f\n",$1,$col_pCA-ca_a,$col_pCA-$col_pCB  >> ca_lacs_shifted_pos
	# 				printf "%-8s%14.5f%14.5f\n",$1,$col_pCB-cb_a,$col_pCA-$col_pCB  >> cb_lacs_shifted_pos
	# 				if($col_pC!=sde){
	# 					printf "%-8s%14.5f%14.5f\n",$1,$col_pC-co_a,$col_pCA-$col_pCB  >> co_lacs_shifted_pos
	# 				}
	# 			}
	# 			
	# 			if ($col_pCA!=sde && $col_pCB!=sde && ($col_pCA-$col_pCB)<0){
	# 			
	# 				printf "%-8s%14.5f%14.5f\n",$1,$col_pCA-ca_a,$col_pCA-$col_pCB  >> ca_lacs_shifted_neg
	# 				printf "%-8s%14.5f%14.5f\n",$1,$col_pCB-cb_a,$col_pCA-$col_pCB  >> cb_lacs_shifted_neg
	# 				if($col_pC!=sde){
	# 					printf "%-8s%14.5f%14.5f\n",$1,$col_pC-co_a,$col_pCA-$col_pCB  >> co_lacs_shifted_neg
	# 				}
	# 			}
	# 			
			}
			else {print $0 >> csi_shifted_output}
		}close ("./csi-diff-assigned-res.out")
		
		col_N=0;col_H=0;col_C=0;col_CA=0;col_CB=0;col_HA=0;
	
		col_pN=0;col_pH=0;col_pC=0;col_pCA=0;col_pCB=0;col_pHA=0;
	
		col_nN=0;col_nH=0;
	
		cs_shifted_output = "./assigned_peaks_res_shifted.out"
	
		while (getline < "./assigned_peaks_res.out" > 0){
			if($0 !~/^#/ && NF>1 && (substr($1,1,1)~/[A-Z]/)){
				for(i=1;i<=NF;i++){
					if ("N"==$i) col_N=i
					if ("H"==$i || "HN"==$i) col_H=i
					if ("CO"==$i || "C"==$i) col_C=i
					if ("CA"==$i) col_CA=i
					if ("CB"==$i) col_CB=i
					if ("HA"==$i) col_HA=i
	
					if ("H-1"==$i || "HN-1"==$i) col_pH=i
					if ("N-1"==$i) col_pN=i
					if ("CO-1"==$i || "C-1"==$i) col_pC=i
					if ("CA-1"==$i) col_pCA=i
					if ("CB-1"==$i) col_pCB=i
					if ("HA-1"==$i) col_pHA=i
	
					if ("N+1"==$i) col_nN=i
					if ("HN+1"==$i || "H+1"==$i) col_nH=i
				}
			}
		}close ("./assigned_peaks_res.out")
		
		while (getline < "./assigned_peaks_res.out" > 0){
			if ($1!~/^#/ && $1 ~ /[0-9]/){
				printf "%-8s",$1 >> cs_shifted_output
				printf "%-20s",$2 >> cs_shifted_output
				printf "%5s",$3 >> cs_shifted_output  
	
				if(col_N>0){printf "%14s",$col_N  >> cs_shifted_output}
				if(col_H>0){printf "%14s",$col_H  >> cs_shifted_output}
				if(col_C>0) if($col_C!=sde){printf "%14.5f",($col_C-co_a)  >> cs_shifted_output}else{printf "%14s", $col_C  >> cs_shifted_output}
				if(col_CA>0) if($col_CA!=sde){printf "%14.5f",($col_CA-ca_a)  >> cs_shifted_output}else{printf "%14s", $col_CA  >> cs_shifted_output}
				if(col_CB>0) if($col_CB!=sde){printf "%14.5f",($col_CB-cb_a)  >> cs_shifted_output}else{printf "%14s", $col_CB  >> cs_shifted_output} 
				if(col_HA>0){printf "%14s",$col_HA  >> cs_shifted_output} 
				
				if(col_pN>0){printf "%14s",$col_pN  >> cs_shifted_output} 
				if(col_pH>0){printf "%14s",$col_pH  >> cs_shifted_output} 
				if(col_pC>0) if($col_pC!=sde){printf "%14.5f",($col_pC-co_a)  >> cs_shifted_output}else{printf "%14s", $col_pC  >> cs_shifted_output}
				if(col_pCA>0) if($col_pCA!=sde){printf "%14.5f",($col_pCA-ca_a)  >> cs_shifted_output}else{printf "%14s", $col_pCA  >> cs_shifted_output}
				if(col_pCB>0) if($col_pCB!=sde){printf "%14.5f",($col_pCB-cb_a)  >> cs_shifted_output}else{printf "%14s", $col_pCB  >> cs_shifted_output}
				if(col_pHA>0){printf "%14s",$col_pHA  >> cs_shifted_output}
				
				if(col_nN>0){printf "%14s",$col_nN  >> cs_shifted_output} 
				if(col_nH>0){printf "%14s",$col_nH  >> cs_shifted_output} 
				printf "\n" >> cs_shifted_output
	
			}else {print $0 >> cs_shifted_output}
		}
}

}
